﻿Public Class frmMain
    'Dichiariamo i tre tipi di Timer
    Private tmrThread As Threading.Timer
    Private tmrTimer As System.Timers.Timer
    Private tmrWindowsForms As System.Windows.Forms.Timer

    'Generatore di numeri casuali
    Private rnd As New Random()
    'Intervallo per tutti i timer
    Const intInterval As Integer = 50

    Private Sub frmMain_Load(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load
        'Per semplicità disabilitiamo il controllo che impedisce
        'ai controlli di essere modificati da thread differenti
        'da quello da cui sono stati creati. Serve solo per 
        'il timer System.Threading.Timer
        Control.CheckForIllegalCrossThreadCalls = False

        'Creiamo System.Threading.Timer, passando come 
        'parametro alla funzione di callback una Label
        tmrThread = New System.Threading.Timer(AddressOf NewRandomNumber, _
            lblSystemThreading, 0, intInterval)

        'Creiamo System.Timers.Timer, impostiamo il 
        'gestore dell'evento e il controllo al quale è
        'associato
        tmrTimer = New System.Timers.Timer(intInterval)
        AddHandler tmrTimer.Elapsed, AddressOf tmrTimer_Elapsed
        tmrTimer.SynchronizingObject = Me
        tmrTimer.Start()

        'Creiamo System.Windows.Forms.Timer e ne impostiamo
        'il gestore dell'evento.
        tmrWindowsForms = New System.Windows.Forms.Timer()
        tmrWindowsForms.Interval = intInterval
        AddHandler tmrWindowsForms.Tick, AddressOf tmrWindowsForms_Tick
        tmrWindowsForms.Start()
    End Sub


    Private Sub frmMain_FormClosed(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'Attendiamo il completamento dell'ultima chiamata alla 
        'funzione di callback per il timer di System.Threading
        Dim ewh As New System.Threading.EventWaitHandle(True, _
            Threading.EventResetMode.AutoReset)
        tmrThread.Dispose(ewh)
        ewh.WaitOne()

        'Interrompiamo gli altri timer
        tmrWindowsForms.Stop()
        tmrTimer.Stop()
    End Sub

    Public Sub tmrWindowsForms_Tick(ByVal state As Object, ByVal e As EventArgs)
        NewRandomNumber(lblSystemWindowsForms)
    End Sub

    Public Sub tmrTimer_Elapsed(ByVal state As Object, ByVal e As EventArgs)
        NewRandomNumber(lblSystemTimers)
    End Sub
    Public Sub NewRandomNumber(ByVal state As Object)
        Dim lbl As Label = DirectCast(state, Label)

        lbl.Text = Math.Round(rnd.NextDouble() * 100).ToString()
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

End Class
